/*
 * $Id: rdcmos.c,v 1.1 1998/09/24 21:08:20 hendriks Exp $
 */
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <asm/io.h>

static inline
unsigned char readreg(int regno) {
  outb(regno, 0x70);
  return inb(0x71);
}

static inline
void writereg(int regno, unsigned char val) {
  outb(regno, 0x70);
  outb(val, 0x71);
}

unsigned char data[128];

int main(int argc, char *argv[]) {
  int i;
  if (ioperm(0x70, 2, 1) == -1) {
    perror("ioperm");
    exit(1);
  }
  
  for (i=0; i < 128; i++) data[i] = readreg(i);

  /* now dump the bits in bit #,value format */
  for(i = 0; i < 128; i++) {
    unsigned char byte = data[i];
    int j;
    for(j = 0; j < 8; j++) {
      int bitnumber = i*8 + j;
      // bit 0 is byte 0 LSB, and so forth.
      int bitvalue = byte & (1<<j) ? 1 : 0;
      printf("%d: %d\n", bitnumber, bitvalue);
    }
  }
}


